<template>
    <div class="list-view">
        <div class="filters-container">
            <!-- <el-input placeholder="输入关键字" v-model="search" clearable class="filter-item"></el-input> -->
            <!-- <el-select class="filter-item" v-model="districtId" clearable v-if="display">
                <el-option v-for="item in district" :key="item.id" :value="item.name" :label="item.name"></el-option>
            </el-select> -->
            <!-- <el-button @click="addRow" type="primary" icon="el-icon-plus" class="filter-item">添加 </el-button> -->
            <!-- <el-button @click="update" type="primary" class="filter-item">一键更新 </el-button> -->
            <!-- <el-button @click="distribute" type="primary" class="filter-item">一键分发 </el-button> -->
            <!-- <el-button
                @click="download"
                type="primary"
                icon="el-icon-download"
                :loading="downloading"
                class="filter-item"
                >导出EXCEL
            </el-button> -->
            <div>
                <span class="span-width">
                    <span class="span-size">考级活动名称</span>
                    <el-input placeholder="输入考级活动名称" v-model="search" clearable class="filter-item"></el-input>
                </span>
                <span class="span-width">
                    <span class="span-size">考级机构名称</span>
                    <el-input placeholder="输入考级机构名称" v-model="agency" clearable class="filter-item"></el-input>
                </span>
                <span class="span-width2">
                    <label class="span-size">考级活动时间</label>
                    <el-date-picker
                        v-model="dateRange"
                        type="daterange"
                        value-format="yyyy-MM-dd"
                        start-placeholder="请选择开始时间"
                        end-placeholder="请选择结束时间"
                        range-separator="至"
                        class="filter-item"
                    >
                    </el-date-picker>
                </span>
            </div>
            <div>
                <span class="span-width">
                    <span class="span-size">承办单位名称</span>
                    <el-input
                        placeholder="输入承办单位名称"
                        v-model="organizer"
                        clearable
                        class="filter-item"
                    ></el-input>
                </span>
                <span class="span-width">
                    <label class="span-size">状态</label>
                    <el-select
                        class="filter-item"
                        v-model="status"
                        clearable
                        placeholder="请选择状态"
                        style="width: 200px"
                    >
                        <el-option
                            v-for="item in statusOptions"
                            :key="item.value"
                            :value="item.value"
                            :label="item.label"
                        ></el-option>
                    </el-select>
                </span>
                <span class="span-width2">
                    <label class="span-size">备案时间</label>
                    <el-date-picker
                        v-model="recordDateRange"
                        type="daterange"
                        value-format="yyyy-MM-dd"
                        start-placeholder="请选择开始时间"
                        end-placeholder="请选择结束时间"
                        range-separator="至"
                        class="filter-item"
                    >
                    </el-date-picker>
                </span>
            </div>
            <div style="padding-left: 20px">
                <el-button @click="getData" type="primary" icon="el-icon-search" class="filter-item">查询 </el-button>
                <el-button
                    @click="download"
                    type="primary"
                    icon="el-icon-download"
                    :loading="downloading"
                    class="filter-item"
                    :disabled="totalElements <= 0"
                    >导出EXCEL
                </el-button>
            </div>
        </div>
        <el-table
            :data="tableData"
            row-key="id"
            ref="table"
            header-row-class-name="table-header-row"
            header-cell-class-name="table-header-cell"
            row-class-name="table-row"
            cell-class-name="table-cell"
            :height="tableHeight"
        >
            <el-table-column v-if="multipleMode" align="center" type="selection" width="50"> </el-table-column>
            <!-- <el-table-column prop="id" label="ID" width="100"> </el-table-column> -->
            <el-table-column prop="examinationName" label="考级活动名称"> </el-table-column>
            <el-table-column prop="examinationStartTime" label="考级活动时间">
                <template slot-scope="{ row }">
                    <span>{{ row.examinationStartTime }} 至 {{ row.examinationEndTime }}</span>
                </template>
            </el-table-column>
            <el-table-column prop="examinationAgency" label="考级机构名称"> </el-table-column>
            <el-table-column prop="organizer" label="承办单位名称"> </el-table-column>
            <el-table-column prop="district" label="考级地点"> </el-table-column>
            <el-table-column prop="recordTime" label="备案时间"> </el-table-column>
            <el-table-column prop="status" label="状态" :formatter="statusFormatter" width="50"> </el-table-column>
            <el-table-column label="操作" align="center" fixed="right" min-width="80">
                <template slot-scope="{ row }">
                    <el-button @click="editRow(row)" type="primary" size="mini" plain>查看</el-button>
                    <!-- <el-button @click="deleteRow(row)" type="danger" size="mini" plain>删除</el-button> -->
                </template>
            </el-table-column>
        </el-table>
        <div class="pagination-wrapper">
            <!-- <div class="multiple-mode-wrapper">
                <el-button v-if="!multipleMode" @click="toggleMultipleMode(true)">批量编辑</el-button>
                <el-button-group v-else>
                    <el-button @click="operation1">批量操作1</el-button>
                    <el-button @click="operation2">批量操作2</el-button>
                    <el-button @click="toggleMultipleMode(false)">取消</el-button>
                </el-button-group>
            </div> -->
            <el-pagination
                background
                @size-change="onSizeChange"
                @current-change="onCurrentChange"
                :current-page="page"
                :page-sizes="[10, 20, 30, 40, 50]"
                :page-size="pageSize"
                layout="total, sizes, prev, pager, next, jumper"
                :total="totalElements"
            >
            </el-pagination>
        </div>
    </div>
</template>
<script>
import { mapState } from 'vuex';
import pageableTable from '@/mixins/pageableTable';

export default {
    name: 'RecordList',
    mixins: [pageableTable],
    created() {
        this.$http
            // .get('/district/NJ')
            .post('/setting/byFlag', { flag: 2 })
            .then(res => {
                this.district = res;
            })
            .catch(e => {
                console.log(e);
                this.$message.error(e.error);
            });
        this.getAdmin();
    },
    data() {
        return {
            multipleMode: false,
            search: '',
            url: '/record/all',
            downloading: false,
            categoryOptions: [{ label: '承办单位', value: 'ORGANIZER' }],
            statusOptions: [{ label: '正常', value: 'NORMAL' }],
            district: [],
            districtId: '',
            display: false,
            status: '',
            recordDateRange: '',
            agency: '',
            organizer: '',
            dateRange: ''
        };
    },
    computed: {
        selection() {
            return this.$refs.table.selection.map(i => i.id);
        },
        ...mapState(['userInfo'])
    },
    methods: {
        categoryFormatter(row, column, cellValue, index) {
            let selectedOption = this.categoryOptions.find(i => i.value === cellValue);
            if (selectedOption) {
                return selectedOption.label;
            }
            return '';
        },
        statusFormatter(row, column, cellValue, index) {
            let selectedOption = this.statusOptions.find(i => i.value === cellValue);
            if (selectedOption) {
                return selectedOption.label;
            }
            return '';
        },
        beforeGetData() {
            // return {
            //     search: this.search,
            //     sort: 'recordTime,desc',
            //     query: {
            //         district: '玄武区',
            //         del: false
            //     }
            // };
            let data = { sort: 'recordTime,desc', query: { del: false } };
            data.query.district = '玄武区';
            if (this.search) {
                data.search = this.search;
            }
            if (this.recordDateRange && this.recordDateRange.length > 0) {
                data.query.recordTime = this.recordDateRange[0] + ',' + this.recordDateRange[1];
            }
            if (this.dateRange && this.dateRange.length > 0) {
                data.query.examinationStartTime = this.dateRange[0] + ',' + this.dateRange[1];
                data.query.examinationEndTime = this.dateRange[0] + ',' + this.dateRange[1];
            }
            if (this.agency) {
                data.query.examinationAgency = this.agency;
            }
            if (this.organizer) {
                data.query.organizer = this.organizer;
            }
            return data;
        },
        toggleMultipleMode(multipleMode) {
            this.multipleMode = multipleMode;
            if (!multipleMode) {
                this.$refs.table.clearSelection();
            }
        },
        addRow() {
            this.$router.push({
                path: '/recordEdit',
                query: {
                    ...this.$route.query
                }
            });
        },
        editRow(row) {
            this.$router.push({
                path: '/recordEdit',
                query: {
                    id: row.id
                }
            });
        },
        download() {
            this.downloading = true;
            this.$axios
                .get('/record/excel', {
                    responseType: 'blob',
                    params: {
                        size: 10000,
                        query: {
                            del: false,
                            district: '玄武区'
                        }
                    }
                })
                .then(res => {
                    console.log(res);
                    this.downloading = false;
                    const downloadUrl = window.URL.createObjectURL(new Blob([res.data]));
                    const link = document.createElement('a');
                    link.href = downloadUrl;
                    link.setAttribute('download', res.headers['content-disposition'].split('filename=')[1]);
                    document.body.appendChild(link);
                    link.click();
                    link.remove();
                })
                .catch(e => {
                    console.log(e);
                    this.downloading = false;
                    this.$message.error(e.error);
                });
        },
        operation1() {
            this.$notify({
                title: '提示',
                message: this.selection
            });
        },
        operation2() {
            this.$message('操作2');
        },
        deleteRow(row) {
            this.$alert('删除将无法恢复，确认要删除么？', '警告', { type: 'error' })
                .then(() => {
                    return this.$http.post(`/record/del/${row.id}`);
                })
                .then(() => {
                    this.$message.success('删除成功');
                    this.getData();
                })
                .catch(e => {
                    if (e !== 'cancel') {
                        this.$message.error(e.error);
                    }
                });
        },
        distribute() {
            this.$alert('已分发到各区县！', '分发', {
                confirmButtonText: '确定'
            });
        },
        update() {
            this.$http
                .get('/record/update')
                .then(res => {
                    this.getData();
                })
                .catch(e => {
                    console.log(e);
                    this.$message.error(e.error);
                });
        },
        getAdmin() {
            let data = this.userInfo.authorities;
            data.forEach(element => {
                if (element.name === 'ROLE_ADMIN') {
                    this.display = true;
                }
            });
            if (!this.display) {
                if (this.userInfo.username.indexOf('xuanwu') >= 0) {
                    this.userDistrict = '玄武区';
                }
            }
        }
    }
};
</script>
<style lang="less" scoped>
.span-size {
    font-size: 14px;
    color: #565b66;
    line-height: 15px;
    padding: 0 10px 0 10px;
}
.span-width {
    width: 330px;
    display: inline-block;
    text-align: right;
}
.span-width2 {
    width: 500px;
    // float: left;
    text-align: right;
    display: inline-block;
}
</style>
